<template>
  <div class="tenant">
    <byTable :source="sourceList.data" :pagination="sourceList.pagination" :config="config" :loading="loading" highlight-current-row
             :selectConfig="selectConfig" :table-events="{
          select: select,
        }" :action-list="[
        {
          text: '添加祝福语',
          action: () => openModal('add'),
        },
      ]" @get-list="getList">
    </byTable>

    <el-dialog z-index="1100" :title="modalType == 'add' ? '添加祝福语' : '编辑祝福语'" v-if="dialogVisible" v-model="dialogVisible" width="800px"
               v-loading="loading">
      <byForm :formConfig="formConfig" :formOption="formOption" v-model="formData.data" :rules="rules" ref="byform">

      </byForm>

      <template #footer>
        <el-button @click="dialogVisible = false" size="large">取 消</el-button>
        <el-button type="primary" @click="submitForm" size="large" :loading="submitLoading">确 定</el-button>
      </template>
    </el-dialog>
  </div>
</template>

<script setup>
import { ElMessage, ElMessageBox } from "element-plus";
import byTable from "@/components/byTable/index";
import byForm from "@/components/byForm/index";
import { computed, nextTick, reactive, ref } from "vue";
const { proxy } = getCurrentInstance();

const router = useRouter();
const loading = ref(false);
const blessingTypeList = ref([]);
const submitLoading = ref(false);
const sourceList = ref({
  data: [],
  pagination: {
    total: 0,
    pageNum: 1,
    pageSize: 10,
  },
});

let rules = ref({
  blessingType: [
    { required: true, message: "请选择祝福语类型", trigger: "change" },
  ],
  blessingContent: [
    { required: true, message: "请输入祝福内容", trigger: "blur" },
  ],
});
let dialogVisible = ref(false);
let modalType = ref("add");
const selectConfig = computed(() => {
  return [
    {
      label: "祝福语类型",
      prop: "blessingType",
      data: blessingTypeList.value,
    },
  ];
});

const config = computed(() => {
  return [
    {
      attrs: {
        label: "祝福语类型",
        prop: "blessingType",
        width: "240",
        align: "left",
      },
      render(type) {
        return proxy.dictValueLabel(type, blessingTypeList.value);
      },
    },
    {
      attrs: {
        label: "祝福内容",
        prop: "blessingContent",
        align: "left",
      },
    },
    {
      attrs: {
        label: "操作",
        width: "120",
        align: "center",
      },
      renderHTML(row) {
        return [
          {
            attrs: {
              label: "修改",
              type: "primary",
              text: true,
            },
            el: "button",
            click() {
              getDtl(row);
            },
          },
          {
            attrs: {
              label: "删除",
              type: "danger",
              text: true,
            },
            el: "button",
            click() {
              ElMessageBox.confirm(
                "此操作将永久删除该数据, 是否继续?",
                "提示",
                {
                  confirmButtonText: "确定",
                  cancelButtonText: "取消",
                  type: "warning",
                }
              ).then(() => {
                //删除
                proxy
                    .post("/blessingLanguage/delete", {
                      id: row.id,
                    })
                    .then((res) => {
                      ElMessage({
                        message: "删除成功",
                        type: "success",
                      });
                      getList();
                    });

              });
            },
          },
        ];
      },
    },
  ];
});

let formData = reactive({
  data: {
    coverList: [],
    audioList: [],
  },
});
const formOption = reactive({
  inline: true,
  labelWidth: 100,
  itemWidth: 100,
  rules: [],
});
const byform = ref(null);

const formConfig = computed(() => {
  return [
    {
      type: "select",
      prop: "blessingType",
      label: "祝福语类型",
      data: blessingTypeList.value,
      required: true,
    },
    {
      type: "input",
      itemType: "textarea",
      rows: 10,
      prop: "blessingContent",
      label: "祝福内容",
      required: true,
    },
  ];
});

const getDictlist = async () => {
  proxy.getDictOne(["blessing_type"]).then((res) => {
    blessingTypeList.value = res["blessing_type"].map((x) => ({
      label: x.dictValue,
      value: x.dictKey,
    }));
  });
};

const getList = async (req) => {
  sourceList.value.pagination = { ...sourceList.value.pagination, ...req };
  loading.value = true;
  proxy
    .post("/blessingLanguage/page", sourceList.value.pagination)
    .then((res) => {
      sourceList.value.data = res.rows;
      sourceList.value.pagination.total = res.total;
      setTimeout(() => {
        loading.value = false;
      }, 200);
    });
};

const openModal = () => {
  dialogVisible.value = true;
  modalType.value = "add";
  formData.data = {
    content: "",
  };
};
const selection = ref({
  data: [],
});
const select = (_selection, row) => {
  selection.value.data = _selection;
};

const getDtl = (row) => {
  modalType.value = "edit";
  proxy.post("/blessingLanguage/detail", { id: row.id }).then((res) => {
    formData.data = res;
    dialogVisible.value = true;
  });
};

const submitForm = () => {
  byform.value.handleSubmit(() => {
    submitLoading.value = true;
    proxy.post("/blessingLanguage/" + modalType.value, formData.data).then(
      () => {
        ElMessage({
          message: modalType.value == "add" ? "添加成功" : "编辑成功",
          type: "success",
        });
        dialogVisible.value = false;
        submitLoading.value = false;
        getList();
      },
      (err) => {
        console.log(err);
        submitLoading.value = false;
      }
    );
  });
};

getDictlist();
getList();
</script>

<style lang='scss' scoped>
.tenant {
  padding: 20px;
  .delete-btn {
    margin-top: 10px;
    margin-left: 25px;
  }
}
.avatar-uploader .avatar {
  width: 110px;
  height: 110px;
  display: block;
  background-color: black;
}
.avatar-uploader .el-upload {
  border: 1px dashed var(--el-border-color);
  border-radius: 6px;
  cursor: pointer;
  position: relative;
  overflow: hidden;
  transition: var(--el-transition-duration-fast);
}
.avatar-uploader .el-upload:hover {
  border-color: var(--el-color-primary);
}
.el-icon.avatar-uploader-icon {
  font-size: 28px;
  color: #8c939d;
  width: 110px;
  height: 110px;
  text-align: center;
  border: 1px dashed var(--el-border-color);
}

.pic {
  object-fit: contain;
  width: 50px;
  height: 50px;
  cursor: pointer;
  vertical-align: middle;
}

.blessingClass {
  background-image: url("../../../assets/victoria/sjk.jpg");
  background-size: cover;
  height: 600px;
  width: 300px;

  padding: 40px 19px;
}
</style>
